package fiber;



import san.core.IApplicationAPI;
import san.ident.Guid;



/**
 *
 * @author Jiri Nohavec
 */
public class SleepFeature extends IFeature {



    private static final long MAX_SLEEP_TIME = 10000L;



    public SleepFeature() {
        super("Suspending threads for given time interval with methods "
              + "Thread.sleep(long) or applicationAPI.sleep(long)");
    }



    @Override
    protected void workerMethod(IApplicationAPI applicationAPI, Guid guid) throws Exception {
        long sleepTime = (long) (Math.random() * MAX_SLEEP_TIME);
        println("Sleeping for " + sleepTime + " [ms]");
        Thread.sleep(sleepTime);
    }
}
