package fiberping;



import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import san.application.ICapsule;
import san.core.ICapsuleAPI;
import san.data.TransmitData;



/**
 *
 * @author Jiri Nohavec
 */
public class FiberPingCapsule implements ICapsule {



    @Override
    public void main(ICapsuleAPI capsuleAPI) {
        TransmitData transmitData = capsuleAPI.getDataLoad();
        boolean returnBack;
        long sendTime;
        long targetTime = System.currentTimeMillis();
        ByteArrayInputStream arrayInputStream = new ByteArrayInputStream(transmitData.getData());
        ObjectInputStream objectInputStream;
        try {
            objectInputStream = new ObjectInputStream(arrayInputStream);
            returnBack = objectInputStream.readBoolean();
            sendTime = objectInputStream.readLong();
        } catch (IOException e) {
            return;
        }
        if (!capsuleAPI.isThisServer(capsuleAPI.getDestination())) {
            return;
        }
        if (returnBack) {
            capsuleAPI.sendData(capsuleAPI.getSourceApplication(), transmitData);
            capsuleAPI.finished();
            return;
        }
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        ObjectOutputStream objectOutputStream;
        try {
            objectOutputStream = new ObjectOutputStream(byteArrayOutputStream);
            objectOutputStream.writeBoolean(true);
            objectOutputStream.writeLong(sendTime);
            objectOutputStream.writeLong(targetTime);
            objectOutputStream.close();
        } catch (IOException e) {
        }
        capsuleAPI.setDestination(capsuleAPI.getSource());
        capsuleAPI.setDataLoad(new TransmitData(byteArrayOutputStream.toByteArray()));
    }
}
