package ping;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import san.application.ICapsule;
import san.core.ICapsuleAPI;
import san.data.TransmitData;
import san.ident.Guid;
import san.ident.NetIdentifier;
import san.logging.ILogger;
import san.logging.LoggerFactory;

public class PingCapsule
        implements ICapsule {

    public void main(ICapsuleAPI capsuleAPI) {
        try {
            TransmitData data = capsuleAPI.getDataLoad();

            ByteArrayInputStream bais = new ByteArrayInputStream(data.getData());
            ObjectInputStream ois = new ObjectInputStream(bais);

            boolean returnBack = ois.readBoolean();

            if (returnBack) {
                if (!(capsuleAPI.isThisServer(capsuleAPI.getDestination()))) {
                    return;
                }

                Guid sourceApp = capsuleAPI.getSourceApplication();

                capsuleAPI.sendData(sourceApp, data);

                capsuleAPI.finished();
                return;
            }

            NetIdentifier pingDestination = capsuleAPI.getDestination();
            if (!(capsuleAPI.isThisServer(pingDestination))) {
                return;
            }

            capsuleAPI.setDestination(capsuleAPI.getSource());

            Date senderDate = new Date(ois.readLong());

            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bos);

            oos.writeBoolean(true);

            oos.writeLong(senderDate.getTime());

            oos.writeLong(new Date().getTime());

            oos.close();

            TransmitData dataBack = new TransmitData(bos.toByteArray());

            capsuleAPI.setDataLoad(dataBack);
        } catch (Exception e) {
            LoggerFactory.createLogger().Log(e, ILogger.LogType.ERROR);
        }
    }
}