package rendezvous2;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import san.application.ICapsule;
import san.core.ICapsuleAPI;
import san.data.TransmitData;
import san.ident.Guid;

/**
 *
 * @author Miroslav Hendrych
 */
public class Rendezvous2Capsule implements ICapsule {
    public void main(ICapsuleAPI capsuleAPI) {
        if (!(capsuleAPI.isThisServer(capsuleAPI.getDestination()))) {
            return;
        }

        String answer = null;
        try {
            Object obj = capsuleAPI.callEntryCallByName(Rendezvous2.ENTRY_GUID, Rendezvous2.ENTRY_NAME, null);
            if (obj == null)
                answer = "Na tomto uzlu neni spusten serverovy program";
            else
                answer = (String)obj;
        } catch (InterruptedException ex) {
            answer = "Doslo k InterruptedException";
        }
        
        try {
            TransmitData data = capsuleAPI.getDataLoad();

            boolean returnBack = data.getData().length>0;//ois.readBoolean();

            if (returnBack) {
                Guid sourceApp = capsuleAPI.getSourceApplication();

                capsuleAPI.sendData(sourceApp, data);

                capsuleAPI.finished();
                return;
            }


            capsuleAPI.setDestination(capsuleAPI.getSource());

            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bos);

            oos.writeUTF(answer);
            oos.close();

            TransmitData dataBack = new TransmitData(bos.toByteArray());

            capsuleAPI.setDataLoad(dataBack);
        } catch (IOException ex) {
            System.out.println(ex);
        }
    }
}
