package tunneler;

import java.io.PrintWriter;
import san.application.IApplication;
import san.core.IApplicationAPI;
import san.data.ReceiveDataListener;
import san.data.TransmitData;
import san.ident.CodePkgIdent;
import san.ident.Guid;
import san.ident.NetIdentifier;

public class Tunneler implements IApplication, ReceiveDataListener {

  private TransmitData received = null; //data prijata z kapsle nebo z Initu
  Guid initGuid = null; //guid initu
  Guid sender = null; //guid odesilatele dat
  //final Object lock = new Object(); //locking zatim nejde

  public void main(String[] args, IApplicationAPI applicationAPI, Guid guid) {

    initGuid = applicationAPI.getServerControl().getInitGuid();

    PrintWriter out = applicationAPI.getStdOut(); //ziskame si vystup do stdout

    try {
      Guid toAddr = null; //komu posilame echo
      Guid toNet = null; //do jake site
      NetIdentifier tunnelEnd = null; //identifikator cile=adresa site+adresa nodu
      try {
        toAddr = Guid.parseGuid(args[0]); //prvnim argumentem je cilovy node

        toNet = Guid.parseGuid(args[1]); //druhym je cilova sit

        tunnelEnd = new NetIdentifier(toAddr, toNet); //slozime identifikator
      } catch (NumberFormatException e) {
        out.print(e); //muze se stat, ze se nepodari parsovat args
        return;
      }

      while (this.received == null) {
        //synchronized (lock) {
          Thread.sleep(1); //notify-wait does not function because we need to write custom classloader to reference application packages
          //wait();
        //}
      }

      if (sender.equals(initGuid)) {
        //odesila init - data jdou kapsli do ciloveho uzlu
        applicationAPI.addOnSendDataListener(guid); //zaregistrovat se pro prijem dat od kapsle
        CodePkgIdent capsulePkgIdent = applicationAPI.getExecutedCodeIdent(); //pro kapsli vratime identifikaci prave bezici aplikace
        applicationAPI.injectCapsule(capsulePkgIdent, tunnelEnd, received); //vlozime kapsli do site

      } else {
        //data odeslala uplne jina aplikace!
        return;
      }

    } catch (Exception e) {
      out.println(e);
    }

  }

  /**
   * The capsule returns carried payload back to application
   * @param sender
   * @param data
   */
  public void receiveData(Guid sender, TransmitData data, IApplicationAPI applicationAPI) {
      this.sender = sender;
      this.received = data;
      //synchronized (lock) { //receive - notify nelze
      //  notifyAll();
      //}
  }
}