/*************************************************************************
 *                           Smart Active Node                           *
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.RendezVous;

/**
 * Parameters of calling entry and result object
 * @author Miroslav Hendrych
 */
public class EntryCallParams {
    private String entryName;
    private Object param;
    private boolean waitingForResult = true;
    private Object result = null;

    public EntryCallParams(String entryName, Object param) {
        this.entryName = entryName;
        this.param = param;
    }

    public String getEntryName() {
        return entryName;
    }

    public Object getParam() {
        return param;
    }

    public Object getResult() {
        return result;
    }

    public synchronized boolean isWaitingForResult() {
        return waitingForResult;
    }

    public synchronized void setResult(Object result) {
        this.result = result;
        this.waitingForResult = false;
        this.notify();
    }

}
