/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.applicationRepository;

import java.util.Set;

import san.codeDistribution.strategies.CodeDistributionStrategy;
import san.data.CodePkgData;
import san.data.TransmitCapsule;
import san.ident.CodePkgIdent;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> Code repository interface.<br>
 * @author Michal Rejda, Petr Stepanek
 * @since 10.10.2007
 * @version 2.0
 */
public interface IRepository {

	public void saveCodePkg(CodePkgIdent hash, byte[] data, String extension, boolean fromFile);

	public CodePackage getCodePkg(CodePkgIdent ident) throws AplPkgException;

	public CodePackage getCodePkg(String name)throws AplPkgException;
	
	public void dontProtectAppFromDeleteAnyLonger(CodePkgIdent i);	
	
	public void tryToSendNextRequestForApp(TransmitCapsule originalCapsule);
	
	public void tryToSendNextRequestForApp();

	public boolean existCodePkg(CodePkgIdent ident);	
	
	public CodePkgData getCodePkgData(CodePkgIdent hash);
	
	public String getCodePkgName(CodePkgIdent i);
	
	public Set<String> getCpBaseOnPkgNamesMapKeys();
	
	public Set<CodePkgIdent> getCpBaseOnPkgIdentificationMapKeys();
	
	public void setRepositoryDir(String repositoryDir);
	
	public void setCodeDistributionStrategy(CodeDistributionStrategy codeDistributionStrategy);

	public int getMaxNewAppsCount();
	
	public void setMaxNewAppsCount(int maxNewAppsCount);
		
}
