/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.console;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.Writer;


/**
 * <b>Title:</b> Smart Active Node<br> 
 * <b>Description:</b> This class is a text console.<br>
 * @author Michal Rejda
 * @since 16.4.2008
 * @version 1.0
 */
public class TextConsole implements IConsole {
	
	/**
	 * @see san.console.IConsole#getIn()
	 */
	public InputStream getIn() {
		return System.in;
	}
	
	/**
	 * @see san.console.IConsole#getOut()
	 */
	public PrintWriter getOut() {
		return new PrintWriter(new ConsoleWriter());
	}
	
	private class ConsoleWriter extends Writer {
		
		public void close() throws IOException {
			
		}
		
		public void flush() throws IOException {
			
		}
		
		public void write(char[] cbuf, int off, int len) throws IOException {
			
		}
		
		public Writer append(CharSequence csq) throws IOException {
			System.out.append(csq);
			System.out.flush();
			return this;
		}
		
		public Writer append(CharSequence csq, int start, int end)
				throws IOException {
			System.out.append(csq, start, end);
			System.out.flush();
			return this;
		}
		
		public void write(char[] cbuf) throws IOException {
			
		}
		
		@Override
		public void write(int c) throws IOException {
			System.out.write(c);
			System.out.flush();
		}
		
		public void write(String str) throws IOException {
			System.out.print(str);
			System.out.flush();
		}
		
		@Override
		public void write(String str, int off, int len) throws IOException {
			System.out.print(str.substring(off, off+len));
			System.out.flush();
		}
	}
}
