/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/

package san.console;

import javax.swing.JFrame;

import san.core.BaseSettings;
import san.localization.Localization;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> There is a window console container. It show the console.<br>
 * @author Michal Rejda
 * @since 28.9.2007
 * @version 1.0
 */
public class WindowConsoleContainer extends JFrame {
	
	private JConsole console;
	
	public WindowConsoleContainer() {
		initComponents();
	}
	/**
	 * Initialize GUI and GUI listeners.
	 */
	private void initComponents() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Object[] values = new Object[]{
				BaseSettings.getSettings().getServerName()
		};
        setTitle(Localization.getLocalization().getString("M000015", values));
        this.setSize(400, 400);
        
        console = new JConsole();
        setContentPane(console);
	}
	
	public void setVisible(boolean b) {
		super.setVisible(b);
		console.grabFocus();
	}
	
	/**
	 * @return the console
	 */
	public JConsole getConsole() {
		return console;
	}
}
