/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.core;

import san.data.TransmitCapsule;
import san.ident.CodePkgIdent;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This listener is used when program code is stored.<br>
 * @author Michal Rejda
 * @since 25.10.2007
 * @version 1.0
 */
public interface CodeStoredListener {

	/**
	 * This method is called when program code was stored.
	 */
	public abstract void codeStored(CodePkgIdent codeIdent);
	
	public abstract void codeStored(TransmitCapsule capsule);
}
