/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.core;

import san.ident.NetIdentifier;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This exception arise when destination is not accessible.<br>
 * @author Michal Rejda
 * @since 26.11.2007
 * @version 1.0
 */
public class DestinationNotAvailableException extends Exception {

	private NetIdentifier destination;

	public DestinationNotAvailableException(String message,
			NetIdentifier destination) {
		super(message);
		this.destination = destination;
	}

	/**
	 * @return the destination
	 */
	public NetIdentifier getDestination() {
		return destination;
	}

	public String toString() {
		return getMessage();
	}
}
