package san.core.fiber.condition;



/**
 *
 * @author Jiri Nohavec
 */
public class ConditionRequest {



    public enum Type {
        INITIALIZE,
        DESTROY,
        WAIT,
        WAIT_TIMEOUT,
        SIGNAL_ONE,
        SIGNAL_ALL,
        GET_WAITING_COUNT
    }



    private volatile int condition;
    private volatile Type type;
    private volatile boolean newCall;



    public ConditionRequest() {
        condition = 0;
        type = null;
        newCall = false;
    }



    public int getCondition() {
        return condition;
    }



    public Type getType() {
        return type;
    }



    public boolean isNewCall() {
        return newCall;
    }



    public void setCall(int condition, Type type) {
        if (newCall) {
            throw new RuntimeException("New condition call before old call was received");
        }
        this.condition = condition;
        this.type = type;
        newCall = true;
    }



    public void newCallReceived() {
        newCall = false;
    }
}
