package san.core.fiber.monitor;



/**
 *
 * @author Jiri Nohavec
 */
public class MonitorRequest {



    public enum Type {
        ENTER,
        EXIT,
        TEST,
        TEST_AND_ENTER
    }



    private volatile Object monitor;
    private volatile Object[] monitorSequenceArray;
    private volatile Type type;
    private volatile boolean newCall;



    public MonitorRequest() {
        monitor = null;
        monitorSequenceArray = null;
        type = null;
        newCall = false;
    }



    public Object getMonitor() {
        return monitor;
    }



    public Object[] getMonitorSequenceArray() {
        return monitorSequenceArray;
    }



    public Type getType() {
        return type;
    }



    public boolean isNewCall() {
        return newCall;
    }



    public void setCall(Object monitor, Type type) {
        if (newCall) {
            throw new RuntimeException("New monitor call before old call was received");
        }
        this.monitor = monitor;
        this.type = type;
        newCall = true;
    }



    public void setMonitorSequenceArray(Object[] monitorSequenceArray) {
        this.monitorSequenceArray = new Object[monitorSequenceArray.length];
        System.arraycopy(monitorSequenceArray, 0, this.monitorSequenceArray, 0, monitorSequenceArray.length);
    }



    public void newCallReceived() {
        newCall = false;
    }
}
