package san.core.fiber.strategy;



import java.util.Collections;
import java.util.List;
import java.util.Queue;
import san.core.Process;



/**
 *
 * @author Jiri Nohavec
 */
public class LoteryStrategy extends ISchedulerStrategy {



    public LoteryStrategy(int cpuCount, Queue<Process> allProcessQueue) {
        super(cpuCount, allProcessQueue);
    }



    @Override
    protected void reschedule() {
        Collections.shuffle((List<Process>) allProcessQueue);
        for (Process process: allProcessQueue) {
            switch (process.getState()) {
                case RUNNING:
                case READY_TO_RUN:
                    selectedProcessQueue.add(process);
                    break;
            }
            if (selectedProcessQueue.size() >= cpuCount) {
                break;
            }
        }
    }
}
