package san.core.fiber.strategy;



import java.util.Queue;
import san.core.Process;



/**
 *
 * @author Jiri Nohavec
 */
public class RoundRobinStrategy extends ISchedulerStrategy {



    public RoundRobinStrategy(int cpuCount, Queue<Process> allProcessQueue) {
        super(cpuCount, allProcessQueue);
    }



    @Override
    protected void reschedule() {
        Process firstProcess;
        Process process = null;
        boolean firstIteration = true;
        if (allProcessQueue.size() == 0) {
            return;
        }
        firstProcess = allProcessQueue.remove();
        while (selectedProcessQueue.size() < cpuCount) {
            if (!firstIteration) {
                process = allProcessQueue.remove();
                allProcessQueue.add(process);
                if (firstProcess == process) {
                    break;
                }
            } else {
                process = firstProcess;
                allProcessQueue.add(process);
                firstIteration = false;
            }
            switch (process.getState()) {
                case RUNNING:
                case READY_TO_RUN:
                    selectedProcessQueue.add(process);
                    break;
            }
        }
    }
}
