package san.interpreter.sanint.classLoading;

import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.References;

import java.util.HashMap;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;

public class ReferenceArray extends Array {
	ClassManager manager;
	java.lang.Class type;
	Reference[] data;
	
	
	public ReferenceArray(int count, java.lang.Class type, ClassManager manager)
	{
		this.manager = manager;
		this.type = type;
		data = new Reference[count];
	}

	public ReferenceArray(Object oldArr, ClassManager manager)
		throws Exception
	{
		this.manager = manager;
		fromObject(null, oldArr);
	}

	@Override
	public int getLength() {
		if (data == null)
			return -1;
		return data.length;
	}

	@Override
	public boolean checkCast(Class cl, int index) {
		return false;
	}

	@Override
	public void getVariable(HardClass currentClass, int index, InterpreterStack stack, References refs) 
	{
		stack.write(refs.putReference(data[index]));
	}

	@Override
	public void setVariable(HardClass currentClass, int index, InterpreterStack stack, References refs,
			long value) throws Exception 
	{
		data[index] = refs.getReference((int)value);
	}
	
	protected void setVariable(int index, Reference value)
	{
		data[index] = value;
	}

	@Override
	public void getVariable(String name, int length, InterpreterStack stack,
			References refs) throws Exception {
		throw new Exception ("This method shoud be never invoked - something went wrong...");
		
	}

	@Override
	public void setVariable(String name, int length, InterpreterStack stack,
			References refs, long value) throws Exception {
		throw new Exception ("This method shoud be never invoked - something went wrong...");
		
	}

	@Override
	public Object toArray(HashMap<Long, Object> convertedObjects)
			throws Exception {
		ReferenceConverter conv = new ReferenceConverter();
		Object ret = java.lang.reflect.Array.newInstance(type, data.length);
		for(int i = 0; i < data.length; i++)
			java.lang.reflect.Array.set(ret, i, conv.toJavaObject(data[i], convertedObjects));
		return ret;
	}
	@Override
	public void fromObject(HashMap<Long, Object> convertedObjects, Object newData)
			throws Exception {
		
		this.type = newData.getClass().getComponentType();
		data = new Reference[java.lang.reflect.Array.getLength(newData)];
		for(int i = 0; i < data.length; i++) 
			data[i] = new SoftReference(java.lang.reflect.Array.get(newData, i), manager);
		
	}

	@Override
	public Reference getSuperReference() 
		throws Exception
	{
		throw new NotImplementedException();
	}
	@Override
	public Class getClassInfo() {
		throw new NotImplementedException();
	}

	@Override
	public boolean isInstanceOf(HardClass currentClass, int classIndex)
			throws Exception {
		throw new Exception();
	}
}
