package san.interpreter.sanint.fiber.monitor;



import san.interpreter.sanint.classLoading.Reference;
import san.interpreter.sanint.classLoading.SoftReference;
import san.interpreter.sanint.fiber.InterpretingException;



/**
 *
 * @author Jiri Nohavec
 */
public class MonitorValidator {



    public static Object validateReference(Reference reference) throws InterpretingException {
        if (reference == null || reference.isNull()) {
            throw new InterpretingException("Synchronization on null object");
        } else if (!(reference instanceof SoftReference)) {
            throw new InterpretingException("Synchronization on non-soft object");
        }
        Object monitor = ((SoftReference) reference).getReference();
        if (monitor == null) {
            throw new InterpretingException("Synchronization on null object");
        } else {
            return monitor;
        }
    }
}
