package san.interpreter.sanint.fiber.override;



/**
 *
 * @author Jiri Nohavec
 */
public class MethodCallOverride {



    private static final IMethodCall[] METHOD_CALL_ARRAY = {
        new SleepMethodCall(),
        new YieldMethodCall(),
        new MonitorMethodCall(),
        new ObjectConditionCall()
    };



    public static IMethodCall tryOverride(String className,
                                          String methodName,
                                          String methodDescriptor) {
        for (IMethodCall methodCall: METHOD_CALL_ARRAY) {
            if (methodCall.compareTo(className, methodName, methodDescriptor)) {
                return methodCall;
            }
        }
        return null;
    }
}
