package san.interpreter.sanint.fiber.override;



import san.core.Process;
import san.interpreter.sanint.classLoading.Reference;
import san.interpreter.sanint.fiber.InterpretingException;
import san.interpreter.sanint.fiber.monitor.MonitorValidator;
import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.References;



/**
 *
 * @author Jiri Nohavec
 */
public class MonitorMethodCall extends IMethodCall {



    public MonitorMethodCall() {
        super(false);
        addClass("san.core.IApplicationAPI");
        addClass("san.core.ICapsuleAPI");
        addMethod("monitorEnter", "(Ljava/lang/Object;)V");
        addMethod("monitorExit", "(Ljava/lang/Object;)V");
        addMethod("monitorTest", "(Ljava/lang/Object;)Z");
    }



    @Override
    public void execute(References references,
                        InterpreterStack stack,
                        Process process) throws InterpretingException {
        int referenceValue = stack.readRef();
        stack.writeRef(referenceValue);
        Reference monitorReference = references.getReference(referenceValue);
        MonitorValidator.validateReference(monitorReference);
    }
}
