package san.interpreter.sanint.fiber.override;



import san.core.Process;
import san.interpreter.sanint.fiber.InterpretingException;
import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.References;



/**
 *
 * @author Jiri Nohavec
 */
public class ObjectConditionCall extends IMethodCall {



    public ObjectConditionCall() {
        super(true);
        addClass("java.lang.Object");
        addMethod("wait", "()V");
        addMethod("wait", "(J)V");
        addMethod("wait", "(JI)V");
        addMethod("notify", "()V");
        addMethod("notifyAll", "()V");
    }



    @Override
    public void execute(References references,
                        InterpreterStack stack,
                        Process process) throws InterpretingException {
        throw new InterpretingException("Object class synchronization is not supported");
    }
}
