package san.interpreter.sanint.fiber.stack;



import san.interpreter.sanint.classLoading.Class;
import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.References;



/**
 *
 * @author Jiri Nohavec
 */
public class StaticVariableCallStackLevel extends CallStackLevel {



    private References references;
    private InterpreterStack stack;
    private Class staticVariableClass;
    private String staticVariableName;
    private boolean isGet;



    public StaticVariableCallStackLevel() {
        super();
        setAuxiliaryCallFlag();
    }



    public void set(References references,
                    InterpreterStack stack,
                    Class staticVariableClass,
                    String staticVariableName,
                    boolean isGet) {
        this.references = references;
        this.stack = stack;
        this.staticVariableClass = staticVariableClass;
        this.staticVariableName = staticVariableName;
        this.isGet = isGet;
        setUsedFlag();
    }



    @Override
    public void runAuxiliaryCall() throws Exception {
        if (isGet) {
            staticVariableClass.getStaticVariable(staticVariableName, stack, references);
        } else {
            staticVariableClass.setStaticVariable(staticVariableName, stack, references);
        }
    }
}
