/*************************************************************************
 *                           Smart Active Node                           * 
 *                      copyright (C) 2007 KIV-FAV-ZCU                   *
 *************************************************************************
 * The licence for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/

package san.interpreter.sanint.test;

import java.io.ByteArrayOutputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Date;


/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> Representation of some data.<br>
 * @author Jan Boháč, Michal Rejda
 * @since 30.10.2006
 * @version 1.0
 */
public class TransmitData implements Serializable {
	
	private byte[] data;
	
	public TransmitData(){
		this.data = null;
	}
	
	public TransmitData(byte[] data) {
		this.data = data;
	}
	
	public void setData(byte[] data) {
		this.data = data;
	}
	
	public String toString() {
		String s = "";
		for (int i = 0; i < data.length; i++) {
			s += data[i] + "";
		}
		return s;
	}
	
	public byte[] getData() {
		try
		{
			NetIdentifier pingDestination = new NetIdentifier();
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			ObjectOutputStream oos = new ObjectOutputStream(bos);
			oos.writeBoolean(false);	//we are on the back way
			oos.writeObject(pingDestination);	//destination of the ping (this node)
			oos.writeObject(new Date());	//timestamp
			oos.close();
			return bos.toByteArray();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
}
