/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.networkInterfaces;

import san.data.TransmitCapsule;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> IPastReceiving.java<br>
 * This interface is used by network interfaces when capsule is received. This
 * interface specifies what to do when capsule is received.
 * @author Michal Rejda
 * @since 6.12.2007
 * @version 1.0
 */
public interface IPastReceiving {

	/**
	 * Capsule has been received. This method specifies what to do with the
	 * capsule.
	 */
	public abstract void received(TransmitCapsule capsule);
}
