/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.routing;

import san.ident.NetIdentifier;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This interface provides routing informations.<br>
 * @author Michal Rejda
 * @since 30.10.2007
 * @version 1.0
 */
public interface IRouting {

	/**
	 * Return true if this node has the network identifier.
	 */
	public boolean isThisNode(NetIdentifier ident);

	/**
	 * Return direction to the destination. This direction is nearest neighbour
	 * in the direction. It's a gateway for this destination.
	 */
	public NetIdentifier getDirectionTo(NetIdentifier destination);
	
	/**
	 * Return local network identifier in determined direction. It's a interface
	 * identifier of interface over there lead the way to the destination.
	 */
	public NetIdentifier getLocalNetIdentInDirection(NetIdentifier destination);
}
