/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package san.security.Crypto;

import java.io.*;
import java.security.*;

/**
 *
 * @author Vladimír Aubrecht
 */
public class KeyGenerator
{

    private PublicKey publicKey;
    private PrivateKey privateKey;

    public KeyGenerator()
    {
        try
        {
            KeyPair pair = KeyPairGenerator.getInstance("RSA").generateKeyPair();

            this.publicKey = pair.getPublic();
            this.privateKey = pair.getPrivate();
        }
        catch (NoSuchAlgorithmException ex)
        {
            java.util.logging.Logger.getLogger(KeyGenerator.class.getName()).log(java.util.logging.Level.SEVERE, ex.getMessage());
        }
    }

    public PublicKey getPublicKey()
    {
        return this.publicKey;
    }

    public PrivateKey getPrivateKey()
    {
        return this.privateKey;
    }

    public void writeKey(String filename, byte[] keyContent)
    {
        try
        {
            FileOutputStream fos = new FileOutputStream(filename);
            fos.write(keyContent);
            fos.flush();
            fos.close();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
