/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package san.security;

import java.lang.management.ManagementFactory;
import java.lang.management.OperatingSystemMXBean;

/**
 *
 * @author Vladimír Aubrecht
 */
public class ResourceMonitor
{
    private static ResourceMonitor instance;
    private OperatingSystemMXBean osMXBean;

    private ResourceMonitor()
    {
         osMXBean = ManagementFactory.getOperatingSystemMXBean();
    }

    public static ResourceMonitor getInstance()
    {
        if (instance == null)
            instance = new ResourceMonitor();

        return instance;
    }

    public long getMemorySize()
    {
        return Runtime.getRuntime().maxMemory();
    }

    public long getFreeMemorySize()
    {
        return Runtime.getRuntime().freeMemory();
    }
    
    public long getFullMemorySize()
    {
        return Runtime.getRuntime().totalMemory();
    }

    public int getCPUCount()
    {
        return osMXBean.getAvailableProcessors();
    }

    public double getCurrentCPULoad()
    {
        return osMXBean.getSystemLoadAverage();
    }
}
