public class PiJRE extends Thread {



    private static final int ITERATION_COUNT = 1000000;
    private static final int THREAD_COUNT = 10;



    public void run() {
        System.out.println("Calculating PI with " + ITERATION_COUNT + " iterations...");
        int printScale = (ITERATION_COUNT / 100);
        double pi = 0.0;
        double segment;
        for (int i = 0; i <= ITERATION_COUNT; i++) {
            segment = 4.0 / (2 * i + 1);
            if (i % 2 != 0) {
                segment = -segment;
            }
            pi += segment;
            if (i % printScale == 0) {
                System.out.println("Progress " + (i / printScale) + "%");
            }
        }
        System.out.format("PI = %.20f%n", pi);
    }



    public static void main(String[] args) {
        long timeStart = System.currentTimeMillis();
        Thread[] threadArray = new Thread[THREAD_COUNT];
        for (int i = 0; i < THREAD_COUNT; i++) {
            threadArray[i] = new PiJRE();
            threadArray[i].start();
        }
        for (int i = 0; i < THREAD_COUNT; i++) {
            try {
                threadArray[i].join();
            } catch (InterruptedException e) {
            }
        }
        System.out.println("Finished in: " + (System.currentTimeMillis() - timeStart) + " [ms]");
    }
}
