package fiber;



import san.core.IApplicationAPI;
import san.ident.Guid;



/**
 *
 * @author Jiri Nohavec
 */
public class PiSingleFeature extends IFeature {



    private static final int ITERATION_COUNT = 1000000;



    public PiSingleFeature() {
        super("Calculating PI in separate threads with no cooperation");
    }



    private double piSegment(int index) {
        double segment = 4.0 / (2 * index + 1);
        if (index % 2 != 0) {
            segment = -segment;
        }
        return segment;
    }



    @Override
    protected void workerMethod(IApplicationAPI applicationAPI, Guid guid) throws Exception {
        println("Calculating PI with " + ITERATION_COUNT + " iterations...");
        int printScale = (ITERATION_COUNT / 100);
        double pi = 0.0;
        for (int i = 0; i <= ITERATION_COUNT; i++) {
            pi += piSegment(i);
            if (i % printScale == 0) {
                println("Progress " + (i / printScale) + "%");
            }
        }
        formatln("PI = %.20f", pi);
    }
}
