/*************************************************************************
 *                           Smart Active Node                           * 
 *                      copyright (C) 2007 KIV-FAV-ZCU                   *
 *************************************************************************
 * The licence for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package init;


import java.io.PrintWriter;

import san.application.IApplication;
import san.core.ExecuteException;
import san.core.IApplicationAPI;
import san.ident.Guid;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> Init.java<br>
 * @author Michal Rejda
 * @since 8.11.2007
 * @version 1.0
 */
public class Init implements IApplication {

	public void main(String[] args, IApplicationAPI applicationAPI, Guid guid) {
		applicationAPI.getServerControl().createConsole(applicationAPI.getId());
		PrintWriter out = applicationAPI.getStdOut();

//                if (applicationAPI.logUser("golem2", "text"))
//                {
//                    out.println("User logged as golem2");
//                }

                try {
			Guid loginGuid = applicationAPI.runApplication("shell", null);
			applicationAPI.waitForApplication(loginGuid);
		}
		catch (InterruptedException e) {
			out.write(e.getMessage());
		}
		catch (ExecuteException e) {
			out.write(e.getMessage());
		}
	}
}
