package remoteShell;

import ping.*;
import java.io.*;
import java.util.Date;
import san.application.ICapsule;
import san.core.ICapsuleAPI;
import san.core.IServerControl;
import san.data.TransmitData;
import san.ident.Guid;
import san.ident.NetIdentifier;
import san.logging.ILogger;
import san.logging.LoggerFactory;

public class RemoteShellCapsule implements ICapsule
{
    public void main(ICapsuleAPI capsuleAPI) {
        try {

            if (!(capsuleAPI.isThisServer(capsuleAPI.getDestination()))) {
                    return;
                }

            TransmitData data = capsuleAPI.getDataLoad();

            RemoteCommand cmd = new RemoteCommand("");

            Util.readCapsuleData(data, cmd);

            if (!(capsuleAPI.isThisServer(capsuleAPI.getDestination())))
                return;


            if (cmd.isPathToSource())
            {
                Guid sourceApp = capsuleAPI.getSourceApplication();
                capsuleAPI.sendData(sourceApp, data);
                capsuleAPI.finished();
                System.out.println("Prijmuto zpatky...");
                return;
            }
            else
            {
                cmd.setIsPathToSource();

                String command = cmd.getCommand();
                if (command.equals("getPublicKey"))
                {
                    cmd.setArgument("TSSSS");
                }
                else if (command.equals("login"))
                {
                    cmd.setArgument("OK");
                }
                else if (command.equals("exit"))
                {

                }

                data = Util.createCapsuleData(cmd);

                NetIdentifier remoteShellDestination = capsuleAPI.getDestination();
                capsuleAPI.setDestination(capsuleAPI.getSource());
                capsuleAPI.setSource(remoteShellDestination);

                Guid sourceApp = capsuleAPI.getSourceApplication();
                capsuleAPI.sendData(sourceApp, data);
                capsuleAPI.finished();
                //capsuleAPI.setDataLoad(data);
                System.out.println("Posilam zpatky ...");
            }

        } catch (Exception e) {
            LoggerFactory.createLogger().Log(e, ILogger.LogType.ERROR);
        }
    }
}