/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package remoteShell;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import san.core.ExecuteException;
import san.core.IApplicationAPI;
import san.application.IApplication;
import san.data.ReceiveDataListener;
import san.data.TransmitData;
import san.ident.CodePkgIdent;
import san.ident.Guid;
import san.ident.NetIdentifier;


/**
 *
 * @author Vladimír Aubrecht
 */
public class Util
{
    interface ICommand
    {
        public void setCommand(String command);
        public void setSourceAddress(String sourceAddress);
        public void setSourceNet(String sourceNet);
        public void setDestinationAddress(String destinationAddress);
        public void setDestinationNet(String destinationNet);
        public void setArgument(String arg);
        public void setArgument2(String arg);
        public void setIsPathToSource();

        public boolean isPathToSource();
        public String getSourceAddress();
        public String getSourceNet();
        public String getDestinationAddress();
        public String getDestinationNet();
        public String getCommand();
        public String getArgument();
        public String getArgument2();
    }

    public static void waitForReceivedData(TransmitData received) throws Exception
    {
        while (received == null)
        {
            Thread.sleep(1L);
            System.out.println("Prooooc?");
        }

        if (received == null)
            throw new Exception("Chyba pri prijmu dat od capsule");
    }

    public static TransmitData createCapsuleData(ICommand command) throws Exception
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(bos);

        oos.writeBoolean(command.isPathToSource());
        oos.writeUTF(command.getCommand());
        oos.writeUTF(command.getArgument());
        oos.writeUTF(command.getArgument2());

        oos.close();
        TransmitData data = new TransmitData(bos.toByteArray());

        return data;
    }

    public static NetIdentifier getDestination(String addr, String net)
    {
            Guid toAddr = null;
            Guid toNet = null;
            NetIdentifier pingDst = null;
            try
            {
                toAddr = Guid.parseGuid(addr);
                toNet = Guid.parseGuid(net);

                pingDst = new NetIdentifier(toAddr, toNet);
            }
            catch (NumberFormatException e)
            {
                e.printStackTrace();
            }

            return pingDst;
    }

    public static void readCapsuleData(TransmitData capsuleData, ICommand returnValue) throws Exception
    {
        System.out.println("Prestavam cekat ...");
        ByteArrayInputStream bais = new ByteArrayInputStream(capsuleData.getData());
        ObjectInputStream ois = new ObjectInputStream(bais);

        boolean pathBack = ois.readBoolean();
        String cmd = ois.readUTF();
        String arg = ois.readUTF();
        String arg2 = ois.readUTF();

        if (pathBack)
            returnValue.setIsPathToSource();
        
        returnValue.setCommand(cmd);
        returnValue.setArgument(arg);
        returnValue.setArgument2(arg2);

        System.out.println("Vse jsem precetl ...");
    }

    public static void sendCapsule(IApplicationAPI applicationAPI, NetIdentifier netIdent, ICommand command) throws Exception
    {

        CodePkgIdent capsulePkgIdent = applicationAPI.getExecutedCodeIdent();
        applicationAPI.injectCapsule(capsulePkgIdent, netIdent, createCapsuleData(command));
    }
}
