package rendezvous;

import java.util.Random;
import san.core.IApplicationAPI;
import san.ident.Guid;

/**
 *
 * @author Miroslav Hendrych
 */
public class RendezVousClnt {
    private int val = 0;
    private int minus = 50;
    private int plus = 100;
    private int vysledek = plus-minus;
    private Random rnd;

    public RendezVousClnt(IApplicationAPI applicationAPI) {
        this.rnd = new Random();
        int cnt=plus+minus;
        Integer[] plusyArr = getCallsID(applicationAPI, "plus");
        Integer[] minusyArr = getCallsID(applicationAPI, "minus");

        for (int i=0; i<cnt; i++) {
            boolean spustPlus;
            do {
                spustPlus = rnd.nextBoolean();
            } while (spustPlus && plus==0 || !spustPlus && minus==0);
            if (spustPlus) plus--; else minus--;

            try {
                Object obj = applicationAPI.callEntryCallByID(getRandomID(spustPlus ? plusyArr : minusyArr), new Integer(val));
                val = (Integer)obj;
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
    }

    private Integer[] getCallsID(IApplicationAPI applicationAPI, String entryName) {
        Guid[] guids = applicationAPI.getServerGuidsByName(entryName);
        Integer[] pole = new Integer[guids.length];
        for (int i=0; i<guids.length; i++)
            pole[i] = applicationAPI.getEntryCallIdByGuidName(guids[i], entryName);
        return pole;
    }

    private Integer getRandomID(Integer[] pole) {
        int p = rnd.nextInt(pole.length);
        return pole[p];
    }

    public boolean isCorrect() {
        return val==vysledek;
    }
}
