package rendezvous;

import java.io.PrintWriter;
import san.RendezVous.IRendezvousServer;
import san.core.IApplicationAPI;
import san.ident.Guid;

/**
 *
 * @author Miroslav Hendrych
 */
public class RendezVousSrv implements IRendezvousServer {
    private boolean running = true;
    private int plus = 0;
    private int minus = 0;

    public int getMinus() {
        return minus;
    }

    public int getPlus() {
        return plus;
    }

    public void run(IApplicationAPI applicationAPI, PrintWriter out, Guid guid_main) {
        Guid guid = applicationAPI.registerServer(this);
        applicationAPI.registerEntryCall(guid, "plus");
        applicationAPI.registerEntryCall(guid, "minus");
        applicationAPI.registerEntryCall(guid, "stop");
        out.println("Guid main: "+guid_main);
        out.println("Zaregistrovano: "+guid);
        try {
            applicationAPI.callEntryCallByName(guid_main, RendezVous.ENTRY_CALL, null);
        } catch (InterruptedException ex) { return; }

        while (running) {
            try {
                applicationAPI.makeAccept(guid);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
        applicationAPI.unregisterServer(guid);
    }

    public Object entry(String name, Object param) {
        Integer number = (Integer)param;
        if (name.equals("plus")) {
            number = number.intValue()+1;
            plus++;
        }
        if (name.equals("minus")) {
            number = number.intValue()-1;
            minus++;
        }
        if (name.equals("stop")) {
            running = false;
            return null;
        }

        return number;
    }

}
