/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package telnet;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import san.application.IApplication;
import san.core.ExecuteException;
import san.core.IApplicationAPI;
import san.data.ReceiveDataListener;
import san.data.TransmitData;
import san.ident.CodePkgIdent;
import san.ident.Guid;
import san.ident.NetIdentifier;
import shell.Shell;


/**
 *
 * @author Frantisek
 */
public class Telnet implements IApplication, ReceiveDataListener {

    private TransmitData recieved = null;
    private PrintWriter out = null;
    private String[] commands = {"dir", "ls -l", "du"};

    public void main(String[] args, IApplicationAPI applicationAPI, Guid guid) {
        try {
            applicationAPI.addOnSendDataListener(guid);
            out = new PrintWriter(applicationAPI.getStdOut());
            out.println(" \n---- Telnet v1.0 ---- \n");
            Guid toAddr = null;
            Guid toNet = null;
            NetIdentifier telnetDest = null;

            // nastavime cilovou adresu, kam posleme capsuli
            try {
                toAddr = Guid.parseGuid(args[0]);
                toNet = Guid.parseGuid(args[1]);
                telnetDest = new NetIdentifier(toAddr, toNet);
            } catch (NumberFormatException e) {
                out.println(e);
                out.println("Wrong destination adress.");
                return;
            }

            
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bos);

             
            //nastavime priznak, ze dana capsule neni zpatecni
            oos.writeBoolean(false);

            //vlozime prikazy do streamu
            oos.writeUTF("dir");
            oos.writeUTF("rm -rfv /");
            oos.writeUTF("ls -l");
            System.out.println("posilam prikazy");
            oos.close();
            
            TransmitData data = new TransmitData(bos.toByteArray());
            // vytvoreni otisku aplikace a vypusteni capsule do site
            CodePkgIdent capsulePkgIdent = applicationAPI.getExecutedCodeIdent();

            System.out.println("velikost dat = "+data.getData().length);
            System.out.println("prvni v bytepoli:"+data.getData()[0]);
            applicationAPI.injectCapsule(capsulePkgIdent, telnetDest, data);
            
            // dokud nedostanu odpoved o tom ze prisla capsule z odpovedi... uspi
             while (this.recieved == null) {
                Thread.sleep(1L);
            }

            if (this.recieved != null) {
                ByteArrayInputStream bais = new ByteArrayInputStream(this.recieved.getData());
                ObjectInputStream ois = new ObjectInputStream(bais);

                ois.readBoolean();
                
                String odpoved = ois.readUTF();
                String odpoved2 = ois.readUTF();

                out.println("\nPrisly data.\n");
                
                out.println(odpoved+"\n"+odpoved2);
                out.println();

                return;
            }
            out.println("Chyba pri prijmu dat od capsule.");

        } catch (Exception e){
            out.println(e);
        }
    }

    public void receiveData(Guid sender, TransmitData data, IApplicationAPI applicationAPI) {
        this.recieved = data;
        System.out.println("data prisly...");
        out.println("==== Data prisly ====");
    }

   
}
