/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package telnet;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectOutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import san.application.IApplication;
import san.application.ICapsule;
import san.core.IApplicationAPI;
import san.core.ICapsuleAPI;
import san.data.TransmitData;
import san.ident.Guid;
import san.ident.Guid;
import san.ident.NetIdentifier;
import san.logging.ILogger;
import san.logging.LoggerFactory;
import shell.Shell;

/**
 *
 * @author Frantisek
 */
public class TelnetCapsule implements ICapsule {
       private NetIdentifier thisNode = null;
    public void main(ICapsuleAPI capsuleAPI) {
        try{
            thisNode = capsuleAPI.getDestination();
            TransmitData data = capsuleAPI.getDataLoad();
            ByteArrayInputStream bais = new ByteArrayInputStream(data.getData());

            ObjectInputStream ois = new ObjectInputStream(bais);

            //zjistime zda je priznak nastaven na 'jeZpatecni'capsule
            boolean returnBack = ois.readBoolean();
           
            //otestujeme zda je tato capsule urcena pro tento server - jestli neni -> ignoruj
            if (returnBack) {
               if (!(capsuleAPI.isThisServer(capsuleAPI.getDestination()))) {
                 return;
              }

               //zaslani dat zpet aplikaci ktera vytvorila capsuli
               Guid sourceApp = capsuleAPI.getSourceApplication();
               capsuleAPI.sendData(sourceApp, data);
               capsuleAPI.finished();

                /**
                 * @TODO
                 *
                 * !!! vytvorit novou kopii shelu (virtualni terminal) !!!
                 * prompt by se mohl zmenit treba na  user@node2> misto pouze >
                 * po zadani exit se zavre pouze posledni vytvorena kopie shellu
                 *
                 */

                 
                
               return;
            }

            // je capsule pro tento uzel?
            NetIdentifier pingDestination = capsuleAPI.getDestination();
            if (!(capsuleAPI.isThisServer(pingDestination))) {
                return;
            }

            // nastav cilovy uzel capsule odkud prisla
            capsuleAPI.setDestination(capsuleAPI.getSource());
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(bos);

            //nastav priznak ze tato capsule se vraci (je to vracejici se capsule)
            oos.writeBoolean(true);
            

            oos.writeUTF("Congratulations, now you are conected to: \n");
            oos.writeUTF(thisNode.getAddress().toString()+"\n");

            //uzavreni streamu
            oos.close();

            TransmitData dataBack = new TransmitData(bos.toByteArray());

            //nastav data capsule
            capsuleAPI.setDataLoad(dataBack);
            
        } catch (Exception e){
            LoggerFactory.createLogger().Log(e, ILogger.LogType.ERROR);
        }
    }
    
}
