/*************************************************************************
 *                           Smart Active Node                           *
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/

package san.RendezVous;

import san.applicationRepository.SanCodePkg;
import san.ident.Guid;
import san.interpreter.sanint.classLoading.Reference;

/**
 * This class wraps the actual object which doing rendez-vous accept.
 * @author Miroslav Hendrych
 */
public class RendezvousServerRef implements IRendezvousServer {
    private IRendezvousServer serverTask;
    private san.interpreter.sanint.classLoading.Reference reference;
    private SanCodePkg codePkg;
    private Guid appGuid;

    public SanCodePkg getCodePkg() {
        return codePkg;
    }

    public void setCodePkg(SanCodePkg codePkg) {
        this.codePkg = codePkg;
    }

    public Reference getReference() {
        return reference;
    }

    public Guid getAppGuid() {
        return appGuid;
    }

    public void setAppGuid(Guid appGuid) {
        this.appGuid = appGuid;
    }

    public IRendezvousServer getServerTask() {
        return serverTask;
    }

    public RendezvousServerRef(IRendezvousServer serverTask, Reference reference) {
        this.serverTask = serverTask;
        this.reference = reference;
    }

    public Object entry(String name, Object param) {
        return serverTask.entry(name, param);
    }

}
