/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.applicationRepository;

import san.ident.CodePkgIdent;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This class is a symbolic link to the code package in
 * file system.<br>
 * @author Michal Rejda
 * @since 4.11.2007
 * @version 1.0
 */
public class CodePackageSymLink {

	/**
	 * @uml.property name="pkgName"
	 */
	private String pkgName = "";
	/**
	 * @uml.property name="pkgLocation"
	 */
	private String pkgLocation = "";
	/**
	 * @uml.property name="pkgIdentification"
	 */
	private CodePkgIdent pkgIdentification;
	/**
	 * @uml.property name="since"
	 */
	private long since;
	/**
	 * @uml.property name="fileExtension"
	 */
	private String fileExtension = "";
	/**
	 * @uml.property name="numberOfOpens"
	 */
	private int numberOfOpens = 0;

	/**
	 * Getter of the property <tt>pkgName</tt>
	 * @return Returns the pkgName.
	 * @uml.property name="pkgName"
	 */
	public String getPkgName() {
		return pkgName;
	}

	/**
	 * Setter of the property <tt>pkgName</tt>
	 * @param pkgName The pkgName to set.
	 * @uml.property name="pkgName"
	 */
	public void setPkgName(String pkgName) {
		this.pkgName = pkgName;
	}

	/**
	 * Getter of the property <tt>pkgLocation</tt>
	 * @return Returns the pkgLocation.
	 * @uml.property name="pkgLocation"
	 */
	public String getPkgLocation() {
		return pkgLocation;
	}

	/**
	 * Setter of the property <tt>pkgLocation</tt>
	 * @param pkgLocation The pkgLocation to set.
	 * @uml.property name="pkgLocation"
	 */
	public void setPkgLocation(String pkgLocation) {
		this.pkgLocation = pkgLocation;
	}

	/**
	 * Getter of the property <tt>pkgIdentification</tt>
	 * @return Returns the pkgIdentification.
	 * @uml.property name="pkgIdentification"
	 */
	public CodePkgIdent getPkgIdentification() {
		return pkgIdentification;
	}

	/**
	 * Setter of the property <tt>pkgIdentification</tt>
	 * @param pkgIdentification The pkgIdentification to set.
	 * @uml.property name="pkgIdentification"
	 */
	public void setPkgIdentification(CodePkgIdent pkgIdentification) {
		this.pkgIdentification = pkgIdentification;
	}

	/**
	 * Getter of the property <tt>since</tt>
	 * @return Returns the since.
	 * @uml.property name="since"
	 */
	public long getSince() {
		return since;
	}

	/**
	 * Setter of the property <tt>since</tt>
	 * @param since The since to set.
	 * @uml.property name="since"
	 */
	public void setSince(long since) {
		this.since = since;
	}

	/**
	 * Getter of the property <tt>fileExtension</tt>
	 * @return Returns the fileExtension.
	 * @uml.property name="fileExtension"
	 */
	public String getFileExtension() {
		return fileExtension;
	}

	/**
	 * Setter of the property <tt>fileExtension</tt>
	 * @param fileExtension The fileExtension to set.
	 * @uml.property name="fileExtension"
	 */
	public void setFileExtension(String fileExtension) {
		this.fileExtension = fileExtension;
	}

	/**
	 * Getter of the property <tt>numberOfOpens</tt>
	 * @return Returns the numberOfOpens.
	 * @uml.property name="numberOfOpens"
	 */
	public int getNumberOfOpens() {
		return numberOfOpens;
	}

	/**
	 * Setter of the property <tt>numberOfOpens</tt>
	 * @param numberOfOpens The numberOfOpens to set.
	 * @uml.property name="numberOfOpens"
	 */
	void setNumberOfOpens(int numberOfOpens) {
		this.numberOfOpens = numberOfOpens;
	}
}
