/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.codeDistribution;

/*
 * Overall informations about amount of capsules sent, recieved and forwarded
 */
public class CapsuleTrafficLoggerData {
	
	private long dataCapsulesSentCount = 0;
	private long appCapsulesSentCount = 0;
	private long appReqCapsulesSentCount = 0;
	private long dataCapsulesForwardCount = 0;
	private long appCapsulesForwardCount = 0;
	private long appReqCapsulesForwardCount = 0;

	public CapsuleTrafficLoggerData() {}
	
	public void incrementDataCapsulesSentCount(){
		dataCapsulesSentCount++;
	}
	
	public void incrementAppCapsulesSentCount(){
		appCapsulesSentCount++;
	}
	
	public void incrementAppReqCapsulesSentCount(){
		appReqCapsulesSentCount++;
	}
	
	public void incrementDataCapsulesForwardCount(){
		dataCapsulesForwardCount++;
	}
	
	public void incrementAppCapsulesForwardCount(){
		appCapsulesForwardCount++;
	}
	
	public void incrementAppReqCapsulesForwardCount(){
		appReqCapsulesForwardCount++;
	}

	public long getDataCapsulesSentCount() {
		return dataCapsulesSentCount;
	}

	public long getAppCapsulesSentCount() {
		return appCapsulesSentCount;
	}

	public long getAppReqCapsulesSentCount() {
		return appReqCapsulesSentCount;
	}

	public long getDataCapsulesForwardCount() {
		return dataCapsulesForwardCount;
	}

	public long getAppCapsulesForwardCount() {
		return appCapsulesForwardCount;
	}

	public long getAppReqCapsulesForwardCount() {
		return appReqCapsulesForwardCount;
	}	
	
}