/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.control;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetSocketAddress;

import san.core.Kernel;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;
import org.apache.log4j.Logger;
import san.logging.ILogger.LogType;
import san.logging.LoggerFactory;

/*
 * Simple http server for displaying informations about node status and activities.
 */
public class ControlHttpServer {

	
	private Kernel kernel;

	public ControlHttpServer(Kernel kernel) {
		this.kernel = kernel;
	}
	
	private class MyHandler implements HttpHandler {
	
		public void handle(HttpExchange t) throws IOException {
			InputStream is = t.getRequestBody();
			
			//web page is created in  CapsuleTrafficLogger
			String response = kernel.getCapsuleTrafficLogger().getAppPlacementLogInHtml();
				
			t.sendResponseHeaders(200, response.length());
			OutputStream os = t.getResponseBody();
		
			os.write(response.getBytes());
			os.close();
		}
	}

	public void startHttpServer(int port) {

		HttpServer server = null;
		try {
			server = HttpServer.create(new InetSocketAddress(port), 0);

			server.createContext("/", new MyHandler());
			server.setExecutor(null); // creates a default executor
			server.start();

		} catch (IOException e) {
			//e.printStackTrace();
            Logger.getLogger(Kernel.class).error(e);
		}
	}
}
