package san.core.fiber.monitor.deadlock;



import java.util.ArrayList;
import java.util.List;



/**
 *
 * @author Jiri Nohavec
 */
public class RagNode implements IRagNodeCycle {



    public static final int BFS_FLAG_EMPTY = -1;
    public static final int BFS_FLAG_FIRST = 0;

    private final List<RagNode> waitingForThisList;

    private RagNode previousRagNode;
    private Object object;
    private int bfsFlag;



    public RagNode() {
        waitingForThisList = new ArrayList<RagNode>();
        previousRagNode = null;
        object = null;
        bfsFlag = BFS_FLAG_EMPTY;
    }



    public Iterable<RagNode> getWaitingForThisListIterable() {
        return waitingForThisList;
    }



    public boolean isWaitingForThisListEmpty() {
        return waitingForThisList.isEmpty();
    }



    @Override
    public int waitingForThisListSize() {
        return waitingForThisList.size();
    }



    public void addToWaitingForThisList(RagNode ragNode) {
        waitingForThisList.add(ragNode);
    }



    public RagNode getPreviousRagNode() {
        return previousRagNode;
    }



    public void setPreviousRagNode(RagNode previousRagNode) {
        this.previousRagNode = previousRagNode;
    }



    @Override
    public Object getObject() {
        return object;
    }



    public void setObject(Object object) {
        this.object = object;
    }



    public int getBfsFlag() {
        return bfsFlag;
    }



    public void setBfsFlag(int bfsFlag) {
        this.bfsFlag = bfsFlag;
    }



    public void clear() {
        waitingForThisList.clear();
        previousRagNode = null;
        object = null;
        bfsFlag = BFS_FLAG_EMPTY;
    }
}
