package san.core.fiber.strategy;



import java.util.Queue;
import san.core.Process;



/**
 *
 * @author Jiri Nohavec
 */
public class StrategyManager {



    public static String getDefaultStrategyName() {
        return PriorityStrategy.class.getSimpleName();
    }



    public static boolean isStrategyNameValid(String strategyName) {
        if (strategyName.equalsIgnoreCase(RoundRobinStrategy.class.getSimpleName())) {
            return true;
        }
        if (strategyName.equalsIgnoreCase(MultiLevelQueueStrategy.class.getSimpleName())) {
            return true;
        }
        if (strategyName.equalsIgnoreCase(PriorityStrategy.class.getSimpleName())) {
            return true;
        }
        if (strategyName.equalsIgnoreCase(LoteryStrategy.class.getSimpleName())) {
            return true;
        }
        return false;
    }



    public static ISchedulerStrategy getStrategy(String strategyName,
                                                 int cpuCount,
                                                 Queue<Process> allProcessQueue) throws StrategyException {
        if (strategyName.equalsIgnoreCase(RoundRobinStrategy.class.getSimpleName())) {
            return new RoundRobinStrategy(cpuCount, allProcessQueue);
        }
        if (strategyName.equalsIgnoreCase(MultiLevelQueueStrategy.class.getSimpleName())) {
            return new MultiLevelQueueStrategy(cpuCount, allProcessQueue);
        }
        if (strategyName.equalsIgnoreCase(PriorityStrategy.class.getSimpleName())) {
            return new PriorityStrategy(cpuCount, allProcessQueue);
        }
        if (strategyName.equalsIgnoreCase(LoteryStrategy.class.getSimpleName())) {
            return new LoteryStrategy(cpuCount, allProcessQueue);
        }
        throw new StrategyException("Selected scheduler strategy not found");
    }
}
