/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.data;

import san.core.IApplicationAPI;
import san.ident.Guid;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This interface represent the listener, who is called
 * when some process send data to other process.<br>
 * @author Michal Rejda
 * @since 23.10.2007
 * @version 2.0
 */
public interface ReceiveDataListener {

	/**
	 * This method is called when some process send data to other process.
	 * @param sender Sender process runtime identification.
	 * @param data Data send by the process.
	 */
	public abstract void receiveData(Guid sender, TransmitData data, IApplicationAPI applicationAPI);
}
