package san.interpreter;



import san.interpreter.sanint.classLoading.ClassManager;
import san.interpreter.sanint.fiber.stack.CallStackLevel;
import san.interpreter.sanint.fiber.stack.StaticVariableCallStackLevel;
import san.interpreter.sanint.fiber.stack.SystemInitCallStackLevel;



/**
 *
 * @author Jiri Nohavec
 */
public interface IInterpretingContext {



    public ClassManager getClassManager();
    public CallStackLevel getNewCall();
    public SystemInitCallStackLevel getNewSystemInitCall();
    public StaticVariableCallStackLevel getNewStaticVariableCall();
    public CallStackLevel popCall();
    public CallStackLevel peekCall();
    public int getCallStackSize();
    public boolean isCallStackEmpty();
    public void replaceReturnValue(boolean newValue);
    public void replaceReturnValue(int newValue);
}
