package san.interpreter.sanint.fiber.stack;



import san.interpreter.sanint.classLoading.HardClass;
import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.LocalVars;
import san.interpreter.sanint.interpreter.References;



/**
 *
 * @author Jiri Nohavec
 */
public class CallStackLevel {



    private boolean auxiliaryCall;
    private boolean used;

    private byte[] bytecode;
    private HardClass currentClass;
    private References references;
    private InterpreterStack stack;
    private LocalVars localVars;
    private int returnStackPointer;
    private int programCounter;



    public CallStackLevel() {
        auxiliaryCall = false;
        used = false;
    }



    public boolean isAuxiliaryCall() {
        return auxiliaryCall;
    }



    protected void setAuxiliaryCallFlag() {
        auxiliaryCall = true;
    }



    public void runAuxiliaryCall() throws Exception {
        throw new RuntimeException();
    }



    public boolean isUsed() {
        return used;
    }



    protected void setUsedFlag() {
        used = true;
    }



    public void set(byte[] bytecode,
                    HardClass currentClass,
                    References references,
                    InterpreterStack stack,
                    LocalVars localVars,
                    int returnStackPointer) {
        this.bytecode = bytecode;
        this.currentClass = currentClass;
        this.references = references;
        this.stack = stack;
        this.localVars = localVars;
        this.returnStackPointer = returnStackPointer;
        programCounter = 0;
        setUsedFlag();
    }



    public byte[] getBytecode() {
        return bytecode;
    }



    public HardClass getCurentClass() {
        return currentClass;
    }



    public References getReferences() {
        return references;
    }



    public InterpreterStack getStack() {
        return stack;
    }



    public LocalVars getLocalVars() {
        return localVars;
    }



    public int getReturnStackPointer() {
        return returnStackPointer;
    }



    public int getProgramCounter() {
        return programCounter;
    }



    public void setProgramCounter(int programCounter) {
        this.programCounter = programCounter;
    }
}
