package san.interpreter.sanint.fiber.stack;



import san.interpreter.sanint.classLoading.Class;
import san.interpreter.sanint.classLoading.SoftReference;
import san.interpreter.sanint.interpreter.InterpreterStack;
import san.interpreter.sanint.interpreter.References;



/**
 *
 * @author Jiri Nohavec
 */
public class SystemInitCallStackLevel extends CallStackLevel {



    private References references;
    private InterpreterStack stack;
    private Class systemClass;
    private SoftReference outputStreamSoftReference;
    private SoftReference errorStreamSoftReference;
    private String outputStreamSoftReferenceName;
    private String errorStreamSoftReferenceName;



    public SystemInitCallStackLevel() {
        super();
        setAuxiliaryCallFlag();
    }



    public void set(References references,
                    InterpreterStack stack,
                    Class systemClass,
                    SoftReference outputStreamSoftReference,
                    SoftReference errorStreamSoftReference,
                    String outputStreamSoftReferenceName,
                    String errorStreamSoftReferenceName) {
        this.references = references;
        this.stack = stack;
        this.systemClass = systemClass;
        this.outputStreamSoftReference = outputStreamSoftReference;
        this.errorStreamSoftReference = errorStreamSoftReference;
        this.outputStreamSoftReferenceName = outputStreamSoftReferenceName;
        this.errorStreamSoftReferenceName = errorStreamSoftReferenceName;
        setUsedFlag();
    }



    @Override
    public void runAuxiliaryCall() throws Exception {
        stack.write(references.putReference(outputStreamSoftReference));
        systemClass.setStaticVariable(outputStreamSoftReferenceName, stack, references);
        stack.write(references.putReference(errorStreamSoftReference));
        systemClass.setStaticVariable(errorStreamSoftReferenceName, stack, references);
    }
}
