package san.interpreter.sanint.interpreter;
import java.nio.ByteBuffer;

public class LocalVars 
{
	private static final int INT_CONST_BYTES = 4;
	
	private ByteBuffer localVars = null;
	
	public LocalVars(int capacity) 
	{
		localVars = ByteBuffer.allocate(capacity);
	}
	
	public LocalVars(ByteBuffer wrapedData)
	{
		localVars = wrapedData;
	}
	
	public void AddLocalInt(int index, int value)
	{
		this.localVars.putInt(index * INT_CONST_BYTES,value);
	}
	
	public void AddLocalFloat(int index, float value)
	{
		this.localVars.putFloat(index * INT_CONST_BYTES,value);
	}
	
	public void AddLocalLong(int index, long value)
	{
		this.localVars.putLong(index * INT_CONST_BYTES,value);
	}
	
	public void AddLocalDouble(int index, double value)
	{
		this.localVars.putDouble(index * INT_CONST_BYTES,value);
	}
	
	public int GetLocalInt(int index)
	{
		return this.localVars.getInt(index * INT_CONST_BYTES);
	}
	
	public float GetLocalFloat(int index)
	{
		return this.localVars.getFloat(index * INT_CONST_BYTES);
	}
	
	public long GetLocalLong(int index)
	{
		return this.localVars.getLong(index * INT_CONST_BYTES);
	}
	
	public double GetLocalDouble(int index)
	{
		return this.localVars.getDouble(index * INT_CONST_BYTES);
	}
	
	public int GetLocalReference(int index)
	{
		return GetLocalInt(index);
	}
	
	public void AddLocalReference(int index,int value)
	{
		this.localVars.putInt(index * INT_CONST_BYTES, value);
	}

}
