/*************************************************************************
 *                           Smart Active Node                           * 
 *                      copyright (C) 2007 KIV-FAV-ZCU                   *
 *************************************************************************
 * The licence for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.interpreter.sanint.test;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> The API witch is used by capsule process.<br>
 * @author Michal Rejda
 * @since 21.10.2007
 * @version 1.0
 */
public interface ICapsuleAPI {

	/**
	 * Set capsule destination.
	 */
	public abstract void setDestination(NetIdentifier dest);

	/**
	 * Return data load of the capsule.
	 */
	public abstract TransmitData getDataLoad();

	/**
	 */
	public abstract void getServer();

	/**
	 * Return capsule source node.
	 */
	public abstract NetIdentifier getSource();

	/**
	 * Send data from the capsule to the process.
	 */
	public abstract void sendData(Guid toProcess, TransmitData data);

	/**
	 * Return true if concrete network identifier exist on this server.
	 */
	public abstract boolean isThisServer(NetIdentifier ident);

	/**
	 * Return capsule destination.
	 */
	public abstract NetIdentifier getDestination();

	/**
	 * Return source application ID. This ID is assigned by kernel. It isn't the
	 * code package identification!
	 */
	public abstract Guid getSourceApplication();

	/**
	 * Set data load.
	 */
	public abstract void setDataLoad(TransmitData data);

	/**
	 * Capsule finished. It doesn't want to be send.
	 */
	public abstract void finished();
}
