/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.logging;

import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This class provide logging into console.<br>
 * @author Michal Rejda
 * @since 15.11.2007
 * @version 1.0
 */
public class ConsoleLogger implements ILogger {

	private LogType level;

	/**
	 * Construct Console logger.
	 * @param level log level
	 */
	public ConsoleLogger(LogType level) {
		this.level = level;
	}

	public void Log(Object message, LogType type) {
		// logging only the worst case
		if (level.compareTo(type) > 0)
			return;
		// creating log message
		GregorianCalendar gc = new GregorianCalendar();
		String logRecort = gc.get(Calendar.DAY_OF_MONTH) + "."
				+ (gc.get(Calendar.MONTH) + 1) + "." + gc.get(Calendar.YEAR)
				+ " " + gc.get(Calendar.HOUR_OF_DAY) + ":"
				+ gc.get(Calendar.MINUTE) + ":" + gc.get(Calendar.SECOND) + "."
				+ gc.get(Calendar.MILLISECOND) + " " + type + "" + ": "
				+ message + "\n---\n" + "";
		switch (type) {
			case ERROR :
				System.err.println(logRecort);
				break;
			default :
				System.out.println(logRecort);
				break;
		}
	}

	public void setLogLevel(LogType level) {
		this.level = level;
	}

	public LogType getLogLevel() {
		return level;
	}
}
