/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/

package san.logging;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This interface offer methods to logging information.<br>
 * @author Michal Rejda
 * @since 27.9.2007
 * @version 1.0
 */
public interface ILogger {
	
	/**
	 * Enumeration of types of logging messages.
	 */
	public enum LogType {
		DEBUG,
		INFORMATION,
		WARNING,
		ERROR
	}
	
	/**
	 * Insert new message into log report.
	 * @param message message for logging. Is called toString() method
	 * @param type type of message
	 */
	public void Log(Object message, LogType type);
	
	/**
	 * Set logging level.
	 */
	public void setLogLevel(LogType level);
	
	/**
	 * Return logging level.
	 */
	public LogType getLogLevel();
}
