/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.networkInterfaces;

import san.networkInterfaces.NetInterface;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This interface is a listener that indicate change in
 * network interfaces.<br>
 * @author Michal Rejda
 * @since 6.12.2007
 * @version 1.0
 */
public interface IInterfacesChanged {

	/**
	 * New network interface was added.
	 */
	public abstract void interfaceAdded(NetInterface newInterface);

	/**
	 * Network interface was removed.
	 */
	public abstract void interfaceRemoved(NetInterface removedInterface);
}
