/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package san.security.Crypto;

import java.io.*;
import java.security.*;
import java.security.spec.*;

/**
 *
 * @author Vladimír Aubrecht
 */
public class KeyReader
{
    private KeyFactory keyFactory;

    public KeyReader()
    {
        try
        {
            this.keyFactory = KeyFactory.getInstance("RSA");
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    private byte[] getKeyData(String filename) throws Exception
    {
        FileInputStream fis = new FileInputStream(filename);
        ByteArrayOutputStream baos = new ByteArrayOutputStream();

        int b;
        while ((b = fis.read()) != -1)
        {
           baos.write(b);
        }

        fis.close();
        baos.flush();
        baos.close();

        return baos.toByteArray();
    }
    
    public PrivateKey getPrivateKey(String filename) throws Exception
    {
        byte[] keyData = getKeyData(filename);
        return getPrivateKey(keyData);
    }

    public PrivateKey getPrivateKey(byte[] keyData) throws Exception
    {
        PKCS8EncodedKeySpec encodedPrivateKey = new PKCS8EncodedKeySpec(keyData);
        PrivateKey privateKey = keyFactory.generatePrivate(encodedPrivateKey);

        return privateKey;
    }

    public PublicKey getPublicKey(String filename) throws Exception
    {
        byte[] keyData = getKeyData(filename);
        return getPublicKey(keyData);
    }

    public PublicKey getPublicKey(byte[] keyData) throws Exception
    {
        X509EncodedKeySpec encodedPublicKey = new X509EncodedKeySpec(keyData);
        PublicKey publicKey = keyFactory.generatePublic(encodedPublicKey);

        return publicKey;
    }


}
