/*************************************************************************
 *                           Smart Active Node                           * 
 *                 copyright (c) since 2007 KIV-FAV-ZCU                  *
 *************************************************************************
 * The license for this code is included in LICENSE.txt.  If you did not *
 * get this file with this distribution, request a copy from:            *
 * txkoutny@kiv.zcu.cz                                                   *
 *************************************************************************/
package san.softstate;

/**
 * <b>Title:</b> Smart Active Node<br>
 * <b>Description:</b> This object contains object as value and time, when the
 * object expires.<br>
 * @author Michal Rejda
 * @since 8.2.2008
 * @version 1.0
 */
class TimedObject {

	private Object object;
	private long expires;
	
	public TimedObject(Object object, long expires) {
		this.object = object;
		this.expires = expires;
	}

	/**
	 * @return the object
	 */
	public Object getObject() {
		return object;
	}

	/**
	 * @param object the object to set
	 */
	public void setObject(Object object) {
		this.object = object;
	}

	/**
	 * @return the expires
	 */
	public long getExpires() {
		return expires;
	}

	/**
	 * @param expires the expires to set
	 */
	public void setExpires(long expires) {
		this.expires = expires;
	}
}
